<?php
/**
 * @copyright   Copyright (C) 2012. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jonathan Werner, designfire.de - http://www.designfire.de
 */
 
// no direct access
defined('_JEXEC') or die;
jimport('joomla.plugin.plugin');

class plgSystemOeffnungszeitenbuch extends JPlugin
{
	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}
	
	function onBeforeRoute()
	{
		$app = JFactory::getApplication();
		
		if ($app->isAdmin()) {
			return;
        }
		
		return true;
	}		
				
	function onAfterRoute()
	{
		$app = JFactory::getApplication();
		
		if ($app->isAdmin()) {
			return;
        }
		        				
		return true;
	}
	
	function onBeforeRender()
	{
		$app = JFactory::getApplication();
		
		if ($app->isAdmin()) {
			return;
        }
		        				
		return true;
	}
	
	function onAfterRender()
	{
		$app = JFactory::getApplication();
		
		if ($app->isAdmin()) {
			return;
        }
		
		$text = JResponse::getBody();
		
		if(JString::strpos($text, '[[oeffnungszeitenbuch') !== false)
		{
			$this->language = JFactory::getLanguage();
			$this->language->load('plg_'.$this->_type.'_'.$this->_name, JPATH_SITE.'/plugins/'.$this->_type.'/'.$this->_name, null, true);
			$this->language->load('plg_'.$this->_type.'_'.$this->_name.'.sys', JPATH_SITE.'/plugins/'.$this->_type.'/'.$this->_name, null, true); 
						
			$params = $this->params;
						
			$color_headline_default = JString::str_ireplace('#', '', $params->get('color_headline', 'FFFFFF'));
			$color_headline_bg_default = JString::str_ireplace('#', '', $params->get('color_headline_bg', '489BFF'));
			$color_text_default = JString::str_ireplace('#', '', $params->get('color_text', '000000'));
			$color_widget_bg_default = JString::str_ireplace('#', '', $params->get('color_widget_bg', 'C7E0FF'));
			$color_button_text_default = JString::str_ireplace('#', '', $params->get('color_button_text', 'FFFFFF'));
			$color_button_bg_default = JString::str_ireplace('#', '', $params->get('color_button_bg', '489BFF'));
			
			$location_default = htmlspecialchars($params->get('location', ''));
			$search_default = htmlspecialchars($params->get('search', ''));
			
			$regex = "/(<p\b[^>]*>\s*)?(\{|\[\[)oeffnungszeitenbuch.*?(([a-z0-9A-Z]+((\{|\[)[0-9]+(\}|\]))?='[^']+'.*?\|?.*?)*)(\}|\]\])(\s*<\/p>)?/msi";
			
			preg_match_all($regex,$text,$matches,PREG_OFFSET_CAPTURE | PREG_PATTERN_ORDER);
			
			if (count($matches)>0) {

				for($i=0; $i < count($matches[3]); $i++) {
					
					$match_params = array();
					$match_params_exp = explode('|', $matches[3][$i][0]);
					
					foreach($match_params_exp as $value)
					{
						if(empty($value)) continue;
						
						$match_params_exp2 = explode('=', $value);
						$match_params[trim($match_params_exp2[0])] = trim(JString::str_ireplace("'", '', $match_params_exp2[1]));
					}
					
					$color_headline = empty($match_params['farbe_ueberschrift_text']) ? $color_headline_default : JString::str_ireplace('#', '', $match_params['farbe_ueberschrift_text']);
					$color_headline_bg = empty($match_params['farbe_uberschrift_hintergrund']) ? $color_headline_bg_default : JString::str_ireplace('#', '', $match_params['farbe_uberschrift_hintergrund']);
					$color_text = empty($match_params['farbe_widget_text']) ? $color_text_default : JString::str_ireplace('#', '', $match_params['farbe_widget_text']);
					$color_widget_bg = empty($match_params['farbe_widget_hintergrund']) ? $color_widget_bg_default : JString::str_ireplace('#', '', $match_params['farbe_widget_hintergrund']);
					$color_button_text = empty($match_params['farbe_button_text']) ? $color_button_text_default : JString::str_ireplace('#', '', $match_params['farbe_button_text']);
					$color_button_bg = empty($match_params['farbe_button_hintergrund']) ? $color_button_bg_default : JString::str_ireplace('#', '', $match_params['farbe_button_hintergrund']);
					
					$location = empty($match_params['wo']) ? $location_default : $match_params['wo'];
					$search = empty($match_params['was']) ? $search_default : $match_params['was'];
																				
					$replacement = '<!-- Oeffnungszeitenbuch.de -->
<link rel="stylesheet" type="text/css" href="http://www.oeffnungszeitenbuch.de/rpc/widget/templates/style/searchwidget.css">
<script type="text/javascript" src="http://www.oeffnungszeitenbuch.de/rpc/widget/templates/js/widgetbranding.js"></script>
<div id="oe-searchwidget" style="background: #'.$color_widget_bg.'; color: #'.$color_text.';" class="backgroundStyle">
<div id="oe-searchwidget-title" style="background: #'.$color_headline_bg.'; color: #'.$color_headline.';">'.JText::_('PLG_SYSTEM_OEFFNUNGSZEITENBUCH_DEFAULT_TITLE').'</div>
<iframe id="previewWidget" src="http://www.oeffnungszeitenbuch.de/rpc/widget/widget.php?wo='.$location.'&was='.$search.'&textcolor='.$color_text.'&textbgcolor='.$color_widget_bg.'&buttoncolor='.$color_button_text.'&buttonbgcolor='.$color_button_bg.'" width="150" height="200" frameborder="0" style="overflow: hidden;"></iframe>
<div id="oe-searchwidget-branding"></div>
<script type="text/javascript">getWidgetBranding("'.$location.'", "'.$search.'", "#'.$color_text.'");</script>
</div>
<!-- Ende Oeffnungszeitenbuch.de -->';
					
					$text = JString::str_ireplace($matches[0][$i][0], $replacement, $text);
				}
			}
		}
				
		JResponse::setBody($text);		
		return true;
	}
}